Index: CMT/HEAD/ChangeLog
===================================================================
--- CMT/HEAD/ChangeLog	(revision 586)
+++ CMT/HEAD/ChangeLog	(revision 588)
@@ -1,2 +1,140 @@
+2011-11-27    <rybkin@lal.in2p3.fr> 465
+
+	* source/cmt_system.cxx: In function CmtSystem::remove_file, do not use
+	custom error message
+	* source/cmt_symbol.h: In class Symbol, add const qualifier to
+	check_tag_used function	argument, to resolve_macro_value function
+	* source/cmt_symbol.cxx: idem, add same actions for
+	action_build_broadcast_config as for action_build_constituents_config,
+	action_build_constituent_config
+	* source/cmt_use.h: In class Use, introduce absolute_library_path,
+	remove_library_links functions
+	* source/cmt_use.cxx: Implement introduced functions, in install_library
+	helper function, check return value of called functions, set error (rather
+	than print error message) as appropriate, implement uninstall_library
+	helper function, refactor build_library_links function to use
+	absolute_library_path
+	* source/cmt_deps_builder.h: Make m_filter member of class
+	DepsBuilder::HeaderFilter to be owned by class and cleared accordingly
+	* source/cmt_deps_builder.cxx: In header_file_action, build_deps functions
+	check return value of read function, set error as appropriate, also set
+	error if path specified for dependencies calculation not found. In class
+	DepsBuilder, run function, pass $(app_$(CONSTITUENT)_cppflags),
+	$(lib_$(CONSTITUENT)_cppflags) to external dependencies generator specified
+	via preprocessor_command macro, if any
+	* source/cmt_generators.h: In classes DocumentGenerator, LibraryGenerator,
+	in function build, introduce argument bool& dependencies, in class
+	DocumentGenerator, introduce members Variable m_FILEEXTENSION,
+	FragmentHandle dependency_fragment, in class LibraryGenerator, declare
+	specific function fill_names_outputs. Introduce class
+	PackagesMakefileGenerator, rewrite class DependencyGenerator
+	* source/cmt_generators.cxx: In class LibraryGenerator, implement
+	fill_names_outputs, in class DocumentGenerator function build, add
+	dependency_fragment for each source file with additional template
+	FILEEXTENSION (also added for fragment) so that
+	${CONSTITUENT}_dependencies.make gets rebuilt whenever source file OR its
+	dependencies change. Implement class PackagesMakefileGenerator used to
+	build BCAST mode Makefile. In class DependencyGenerator, re-implement
+	function build (const CmtSystem::cmt_string_vector&) so that it makes use
+	of files and includes from CLI input, if any, enhance its algorithm,
+	enhance	function prepare_header_file_filters so that it makes use of input
+	file dependencies[_CONSTITUENT].in without CMT
+	* source/cmt_generator.h: In class CmtGenerator, remove prepare_use_context
+	function, m_deps_builder member. In class Generator, introduce argument
+	bool& dependencies in build_constituent_makefile function, declare
+	build_library_links_infile, build_dependencies_infile,
+	build_packages_makefile functions
+	* source/cmt_generator.cxx: In class CmtGenerator function reset, reset
+	m_bin, m_output_file_name, m_output_file, m_constituent members, in class
+	Generator, implement build_library_links_infile, build_dependencies_infile,
+	build_packages_makefile functions, in class InGenerator constructor, add
+	document dependency fragment
+	* source/cmt_constituent.h: In class Constituent, change add_for_action
+	function signature
+	* source/cmt_constituent.cxx: In class Constituent, in function parse,
+	do not treat action_value variable definition specially, in function
+	add_for_action, do not assign target_<name> tag to document corresponding
+	to action by default but only if this tag is used somewhere
+	* source/cmt_commands.cxx: In class ArgParser, in function do_build,
+	introduce broadcast_config command and its options processing, enhance
+	dependencies command options processing so that it makes use of files and
+	includes from CLI input and can have global options specified mixed with
+	its options. In class CommandHelp, in constructor, add help info for
+	broadcast_config, dependencies commands
+	* source/cmt_parser.h: In enumeration ActionType, add value
+	action_build_broadcast_config
+	* source/cmt_parser.cxx: In class Cmt, in function do_broadcast, unset
+	CMTBCAST variable in environment of command(s) being broadcast to avoid
+	looping, in function do_build_constituent_config, generate dependencies
+	infile if needed only, incorporate call to do_check_configuration into
+	function do_build_constituents_config so as not	to invoke
+	cmt check configuration command in Makefile, as part of
+	do_build_constituents_config, generate library_links infile, and
+	dependencies infile for constituents without target tag, implement function
+	do_build_broadcast_config to generate broadcast Makefile, and broadcast
+	specific macros Makefile, enhance do_build_library_links function to work
+	with generated library_links infile, make function do_check_configuration
+	set error if non-constant cmtpath_pattern found for package outside CMTPATH
+	- cannot be applied, re-implement do_remove_library_links function making
+	use of remove_library_links from class Use. In function
+	fill_for_all_constituents of class StandardMacroBuilder, print warning
+	message if package requested for import cannot be imported for constituent
+	without target tag during cmt build constituents_config, otherwise during
+	cmt build constituent_config
+	* source/cmt_cmtpath_pattern.h: In class CmtPathPattern, introduce function
+	is_constant
+	* source/cmt_cmtpath_pattern.cxx: Implement is_constant function
+	* source/cmt.h: In class Cmt, introduce function do_build_broadcast_config
+	* mgr/fragments/package: Introduce fragment for broadcast Makefile
+	generation
+	* mgr/fragments/packages_header: idem
+	* mgr/fragments/packages_trailer: idem
+	* mgr/fragments/dependency: Introduce fragment for document Makefile
+	generation
+	* mgr/fragments/dependencies: Use $(build_dependencies) command with
+	dependencies infile and include directories and source files supplied
+	via CLI
+	* mgr/fragments/constituent: In QUICK mode, rebuild constituent Makefile if
+	any requirements file changes. Make constituent uninstall targets
+	independent of constituent Makefile (so that no rebuild happens before
+	uninstall), make remove_library_links dependent on constituent uninstall
+	targets to ensure library links uninstallation order
+	* mgr/fragments/constituent_lock: idem
+	* mgr/fragments/constituents_header:  In QUICK mode, run
+	$(build_library_links) command with library_links infile, if any
+	requirements file changes, keep .DEFAULT target if PEDANTIC is undefined,
+	specify explicit (with empty command) rules for requirements files for
+	optimisation
+	* mgr/fragments/constituents_trailer: In QUICK mode, run
+	$(remove_library_links) command with library_links infile,  make uninstall
+	target (rather than clean target) dependent on remove_library_links target
+	to ensure library links uninstallation
+	* mgr/fragments/make_header: Define dependencies infile for use with
+	$(build_dependencies) command
+	* mgr/fragments/cpp: Add explicit dependency on source file to
+	${CONSTITUENT}_dependencies.make
+	* mgr/fragments/cpp_library: idem
+	* mgr/fragments/c: idem
+	* mgr/fragments/c_library: idem
+	* mgr/fragments/fortran: idem
+	* mgr/fragments/fortran_library: idem
+	* mgr/fragments/lex: idem
+	* mgr/fragments/lex_library: idem
+	* mgr/fragments/yacc: idem
+	* mgr/fragments/yacc_library: idem
+	* mgr/requirements: Declare fragments package, packages_header,
+	packages_trailer, dependency
+	* src/Makefile.core: Add .in to known suffixes
+	* src/Makefile.header: Introduce and implement BCAST mode, making use of
+	cmt build broadcast_config command. In QUICK mode, rebuild constituents or
+	broadcast Makefile and corresponding macros files if any requirements file
+	changes, specify explicit (with empty command) rules for requirements files
+	for optimisation, implement dynamic help messages on targets available for
+	BCAST mode
+	* src/setup.csh: Set MAKEFLAGS, if unset, to set number of job slots to
+	number of processors, and enable CMT QUICK mode
+	* src/setup.sh: idem. Use only shell parameter expansion to determine
+	whether	shell is intercative.
+
 2011-07-06    <rybkin@lal.in2p3.fr> 464
 
Index: CMT/HEAD/mgr/fragments/c
===================================================================
--- CMT/HEAD/mgr/fragments/c	(revision 586)
+++ CMT/HEAD/mgr/fragments/c	(revision 588)
@@ -20,4 +20,6 @@
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
 
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
+
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
 endif
Index: CMT/HEAD/mgr/fragments/c_library
===================================================================
--- CMT/HEAD/mgr/fragments/c_library	(revision 586)
+++ CMT/HEAD/mgr/fragments/c_library	(revision 588)
@@ -20,4 +20,6 @@
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
 
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
+
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
 endif
Index: CMT/HEAD/mgr/fragments/constituent
===================================================================
--- CMT/HEAD/mgr/fragments/constituent	(revision 586)
+++ CMT/HEAD/mgr/fragments/constituent	(revision 588)
@@ -44,4 +44,6 @@
 endif
 
+not_${CONSTITUENT}_dependencies = { n=0; for p in $?; do m=0; for d in $(${CONSTITUENT}_dependencies); do if [ $$p = $$d ]; then m=1; break; fi; done; if [ $$m -eq 0 ]; then n=1; break; fi; done; [ $$n -eq 1 ]; }
+
 ifdef STRUCTURED_OUTPUT
 ${CONSTITUENT}dirs :
@@ -73,7 +75,8 @@
 	  $(cmtexe) -tag=$(tags) $(${CONSTITUENT}_extratags) build constituent_config -out=$(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}
 else
-$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies)
-	if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
-	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ]; then \
+$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies) $(cmt_build_library_linksstamp) $(use_requirements)
+	@if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
+	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ] || \
+	  $(not_${CONSTITUENT}_dependencies) ; then \
 	  test -z "$(cmtmsg)" || \
 	  echo "$(CMTMSGPREFIX)" "(constituents.make) Building ${CONSTITUENT}.make"; \
@@ -89,7 +92,8 @@
 	  $(cmtexe) -f=$(bin)${CONSTITUENT}.in -tag=$(tags) $(${CONSTITUENT}_extratags) build constituent_makefile -without_cmt -out=$(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}
 else
-$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies)
-	if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
-	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ]; then \
+$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies) $(cmt_build_library_linksstamp) $(bin)${CONSTITUENT}.in
+	@if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
+	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ] || \
+	  $(not_${CONSTITUENT}_dependencies) ; then \
 	  test -z "$(cmtmsg)" || \
 	  echo "$(CMTMSGPREFIX)" "(constituents.make) Building ${CONSTITUENT}.make"; \
@@ -104,5 +108,8 @@
 ${CONSTITUENT} :: $(${CONSTITUENT}_dependencies) $(cmt_local_${CONSTITUENT}_makefile) dirs ${CONSTITUENT}dirs
 	$(echo) "(constituents.make) Starting ${CONSTITUENT}"
-	@$(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}
+	@if test -f $(cmt_local_${CONSTITUENT}_makefile); then \
+	  $(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}; \
+	  fi
+#	@$(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}
 	$(echo) "(constituents.make) ${CONSTITUENT} done"
 
@@ -126,12 +133,17 @@
 	$(echo) "(constituents.make) install ${CONSTITUENT} done"
 
-uninstall :: ${CONSTITUENT}uninstall
+uninstall : ${CONSTITUENT}uninstall
 
 $(foreach d,$(${CONSTITUENT}_dependencies),$(eval $(d)uninstall_dependencies += ${CONSTITUENT}uninstall))
 
-${CONSTITUENT}uninstall :: $(${CONSTITUENT}uninstall_dependencies) $(cmt_local_${CONSTITUENT}_makefile)
+${CONSTITUENT}uninstall : $(${CONSTITUENT}uninstall_dependencies) ##$(cmt_local_${CONSTITUENT}_makefile)
 	$(echo) "(constituents.make) Starting uninstall ${CONSTITUENT}"
-	@$(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) uninstall
+	@if test -f $(cmt_local_${CONSTITUENT}_makefile); then \
+	  $(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) uninstall; \
+	  fi
+#	@$(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) uninstall
 	$(echo) "(constituents.make) uninstall ${CONSTITUENT} done"
+
+remove_library_links :: ${CONSTITUENT}uninstall
 
 ifndef PEDANTIC
Index: CMT/HEAD/mgr/fragments/constituent_lock
===================================================================
--- CMT/HEAD/mgr/fragments/constituent_lock	(revision 586)
+++ CMT/HEAD/mgr/fragments/constituent_lock	(revision 588)
@@ -44,4 +44,6 @@
 endif
 
+not_${CONSTITUENT}_dependencies = { n=0; for p in $?; do m=0; for d in $(${CONSTITUENT}_dependencies); do if [ $$p = $$d ]; then m=1; break; fi; done; if [ $$m -eq 0 ]; then n=1; break; fi; done; [ $$n -eq 1 ]; }
+
 ifdef STRUCTURED_OUTPUT
 ${CONSTITUENT}dirs :
@@ -73,7 +75,8 @@
 	  $(cmtexe) -tag=$(tags) $(${CONSTITUENT}_extratags) build constituent_config -out=$(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}
 else
-$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies)
-	if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
-	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ]; then \
+$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies) $(cmt_build_library_linksstamp) $(use_requirements)
+	@if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
+	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ] || \
+	  $(not_${CONSTITUENT}_dependencies) ; then \
 	  test -z "$(cmtmsg)" || \
 	  echo "$(CMTMSGPREFIX)" "(constituents.make) Building ${CONSTITUENT}.make"; \
@@ -89,7 +92,8 @@
 	  $(cmtexe) -f=$(bin)${CONSTITUENT}.in -tag=$(tags) $(${CONSTITUENT}_extratags) build constituent_makefile -without_cmt -out=$(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}
 else
-$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies)
-	if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
-	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ]; then \
+$(cmt_local_${CONSTITUENT}_makefile) : $(${CONSTITUENT}_dependencies) $(cmt_build_library_linksstamp) $(bin)${CONSTITUENT}.in
+	@if [ ! -f $@ ] || [ ! -f $(cmt_local_tagfile_${CONSTITUENT}) ] || \
+	  [ ! -f $(cmt_final_setup_${CONSTITUENT}) ] || \
+	  $(not_${CONSTITUENT}_dependencies) ; then \
 	  test -z "$(cmtmsg)" || \
 	  echo "$(CMTMSGPREFIX)" "(constituents.make) Building ${CONSTITUENT}.make"; \
@@ -107,5 +111,7 @@
 	  retval=$$?; \
 	  trap '${unlock_command} ${CONSTITUENT}${lock_suffix}; exit $${retval}' 1 2 15; \
+	  if test -f $(cmt_local_${CONSTITUENT}_makefile); then \
 	  $(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) ${CONSTITUENT}; \
+	  fi; \
 	  retval=$$?; ${unlock_command} ${CONSTITUENT}${lock_suffix}; exit $${retval}
 	$(echo) "(constituents.make) ${CONSTITUENT} done"
@@ -130,12 +136,17 @@
 	$(echo) "(constituents.make) install ${CONSTITUENT} done"
 
-uninstall :: ${CONSTITUENT}uninstall
+uninstall : ${CONSTITUENT}uninstall
 
 $(foreach d,$(${CONSTITUENT}_dependencies),$(eval $(d)uninstall_dependencies += ${CONSTITUENT}uninstall))
 
-${CONSTITUENT}uninstall :: $(${CONSTITUENT}uninstall_dependencies) $(cmt_local_${CONSTITUENT}_makefile)
+${CONSTITUENT}uninstall : $(${CONSTITUENT}uninstall_dependencies) ##$(cmt_local_${CONSTITUENT}_makefile)
 	$(echo) "(constituents.make) Starting uninstall ${CONSTITUENT}"
-	@$(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) uninstall
+	@if test -f $(cmt_local_${CONSTITUENT}_makefile); then \
+	  $(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) uninstall; \
+	  fi
+#	@$(MAKE) -f $(cmt_local_${CONSTITUENT}_makefile) uninstall
 	$(echo) "(constituents.make) uninstall ${CONSTITUENT} done"
+
+remove_library_links :: ${CONSTITUENT}uninstall
 
 ifndef PEDANTIC
Index: CMT/HEAD/mgr/fragments/constituents_header
===================================================================
--- CMT/HEAD/mgr/fragments/constituents_header	(revision 586)
+++ CMT/HEAD/mgr/fragments/constituents_header	(revision 588)
@@ -26,4 +26,5 @@
 #cmt_final_setup = $(bin)$(package)setup.make
 
+cmt_build_library_linksstamp = $(bin)cmt_build_library_links.stamp
 #--------------------------------------------------------
 
@@ -73,6 +74,7 @@
 
 ifndef QUICK
-all :: build_library_links
-	$(echo) "(constituents.make) all done"
+all :: build_library_links ;
+else
+all :: $(cmt_build_library_linksstamp) ;
 endif
 
@@ -88,6 +90,6 @@
 #	  if test ! -d $(bin) ; then $(mkdir) -p $(bin) ; fi
 
-requirements :
-	@if test ! -r requirements ; then echo "No requirements file" ; fi
+#requirements :
+#	@if test ! -r requirements ; then echo "No requirements file" ; fi
 
 build_library_links : dirs
@@ -97,14 +99,21 @@
 #	$(build_library_links)
 
+$(cmt_build_library_linksstamp) : $(cmt_final_setup) $(cmt_local_tagfile) $(bin)library_links.in
+	$(echo) "(constituents.make) Rebuilding library links"; \
+	 $(build_library_links) -f=$(bin)library_links.in -without_cmt
+	$(silent) \touch $@
+
 makefiles : ;
 
+ifndef PEDANTIC
 .DEFAULT ::
+#.DEFAULT :
 	$(echo) "(constituents.make) $@: No rule for such target" >&2
-#	@echo "#CMT> Warning: $@: Using default commands" >&2; exit
+endif
 
-#	@if test "$@" = "$(cmt_lock_setup)"; then \
-	#  /bin/rm -f $(cmt_lock_setup); \
-	 # touch $(cmt_lock_setup); \
-	#fi
+${CMTROOT}/src/Makefile.core : ;
+ifdef use_requirements
+$(use_requirements) : ;
+endif
 
 #-- end of constituents_header ------
Index: CMT/HEAD/mgr/fragments/constituents_trailer
===================================================================
--- CMT/HEAD/mgr/fragments/constituents_trailer	(revision 586)
+++ CMT/HEAD/mgr/fragments/constituents_trailer	(revision 588)
@@ -1,9 +1,18 @@
 #-- start of constituents_trailer ------
 
-clean :: remove_library_links
+uninstall : remove_library_links ;
+clean ::
+	$(cleanup_echo) $(cmt_build_library_linksstamp)
+	-$(cleanup_silent) \rm -f $(cmt_build_library_linksstamp)
+#clean :: remove_library_links
 
 remove_library_links ::
+ifndef QUICK
 	$(echo) "(constituents.make) Removing library links"; \
 	  $(remove_library_links)
+else
+	$(echo) "(constituents.make) Removing library links"; \
+	  $(remove_library_links) -f=$(bin)library_links.in -without_cmt
+endif
 
 makefilesclean ::
@@ -15,9 +24,3 @@
 clean :: makefilesclean
 
-binclean :: clean
-	$(echo) "(constituents.make) Removing binary directory $(bin)"
-	@if test ! "$(bin)" = "./"; then \
-	  /bin/rm -rf $(bin); \
-	fi
-
 #-- end of constituents_trailer ------
Index: CMT/HEAD/mgr/fragments/cpp
===================================================================
--- CMT/HEAD/mgr/fragments/cpp	(revision 586)
+++ CMT/HEAD/mgr/fragments/cpp	(revision 588)
@@ -20,4 +20,6 @@
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
 
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
+
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
 endif
Index: CMT/HEAD/mgr/fragments/cpp_library
===================================================================
--- CMT/HEAD/mgr/fragments/cpp_library	(revision 586)
+++ CMT/HEAD/mgr/fragments/cpp_library	(revision 588)
@@ -20,4 +20,6 @@
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
 
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
+
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
 endif
Index: CMT/HEAD/mgr/fragments/dependencies
===================================================================
--- CMT/HEAD/mgr/fragments/dependencies	(revision 586)
+++ CMT/HEAD/mgr/fragments/dependencies	(revision 588)
@@ -1,17 +1,9 @@
-#-- start of dependency ------------------
+#-- start of dependencies ------------------
 ifneq ($(MAKECMDGOALS),${CONSTITUENT}clean)
 ifneq ($(MAKECMDGOALS),uninstall)
 
-#$(bin)${CONSTITUENT}_dependencies.make :: dirs
-
-ifndef QUICK
-$(bin)${CONSTITUENT}_dependencies.make : ${LINE} $(use_requirements) $(cmt_final_setup_${CONSTITUENT})
-else
-$(bin)${CONSTITUENT}_dependencies.make :
-endif
+$(bin)${CONSTITUENT}_dependencies.make : $(use_requirements) $(cmt_final_setup_${CONSTITUENT})
 	$(echo) "(${CONSTITUENT}.make) Rebuilding $@"; \
-	  $(build_dependencies) ${CONSTITUENT} -all_sources -out=$@ ${LINE}
-
-#$(${CONSTITUENT}_dependencies)
+	  $(build_dependencies) -out=$@ -start_all ${LINE} -end_all $(includes) $(app_${CONSTITUENT}_cppflags) $(lib_${CONSTITUENT}_cppflags) ${CONSTITUENT} $? -f=$(cmt_dependencies_in_${CONSTITUENT}) -without_cmt
 
 -include $(bin)${CONSTITUENT}_dependencies.make
@@ -19,3 +11,3 @@
 endif
 endif
-#-- end of dependency -------------------
+#-- end of dependencies -------------------
Index: CMT/HEAD/mgr/fragments/dependency
===================================================================
--- CMT/HEAD/mgr/fragments/dependency	(revision 588)
+++ CMT/HEAD/mgr/fragments/dependency	(revision 588)
@@ -0,0 +1,11 @@
+#-- start of dependency ------------------
+ifneq ($(MAKECMDGOALS),${CONSTITUENT}clean)
+ifneq ($(MAKECMDGOALS),uninstall)
+
+$(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILEEXTENSION}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
+
+endif
+endif
+#-- end of dependency -------------------
Index: CMT/HEAD/mgr/fragments/fortran
===================================================================
--- CMT/HEAD/mgr/fragments/fortran	(revision 586)
+++ CMT/HEAD/mgr/fragments/fortran	(revision 588)
@@ -2,4 +2,6 @@
 
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
  
 $(bin)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
Index: CMT/HEAD/mgr/fragments/fortran_library
===================================================================
--- CMT/HEAD/mgr/fragments/fortran_library	(revision 586)
+++ CMT/HEAD/mgr/fragments/fortran_library	(revision 588)
@@ -2,4 +2,6 @@
 
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
  
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
Index: CMT/HEAD/mgr/fragments/lex
===================================================================
--- CMT/HEAD/mgr/fragments/lex	(revision 586)
+++ CMT/HEAD/mgr/fragments/lex	(revision 588)
@@ -2,4 +2,6 @@
 
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
 
 $(bin)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
Index: CMT/HEAD/mgr/fragments/lex_library
===================================================================
--- CMT/HEAD/mgr/fragments/lex_library	(revision 586)
+++ CMT/HEAD/mgr/fragments/lex_library	(revision 588)
@@ -2,4 +2,6 @@
 
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
 
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
Index: CMT/HEAD/mgr/fragments/make_header
===================================================================
--- CMT/HEAD/mgr/fragments/make_header	(revision 586)
+++ CMT/HEAD/mgr/fragments/make_header	(revision 588)
@@ -46,4 +46,5 @@
 
 cmt_final_setup_${CONSTITUENT} = $(bin)setup_${CONSTITUENT}.make
+cmt_dependencies_in_${CONSTITUENT} = $(bin)dependencies_${CONSTITUENT}.in
 #cmt_final_setup_${CONSTITUENT} = $(bin)${PACKAGE}_${CONSTITUENT}setup.make
 cmt_local_${CONSTITUENT}_makefile = $(bin)${CONSTITUENT}.make
@@ -52,4 +53,5 @@
 
 cmt_final_setup_${CONSTITUENT} = $(bin)setup.make
+cmt_dependencies_in_${CONSTITUENT} = $(bin)dependencies.in
 #cmt_final_setup_${CONSTITUENT} = $(bin)${PACKAGE}setup.make
 cmt_local_${CONSTITUENT}_makefile = $(bin)${CONSTITUENT}.make
@@ -83,4 +85,5 @@
 endif
 
+${CMTROOT}/src/Makefile.core : ;
 ifdef use_requirements
 $(use_requirements) : ;
Index: CMT/HEAD/mgr/fragments/package
===================================================================
--- CMT/HEAD/mgr/fragments/package	(revision 588)
+++ CMT/HEAD/mgr/fragments/package	(revision 588)
@@ -0,0 +1,105 @@
+
+cmt_${PACKAGE}_${ISLOCAL} = 1
+
+${PACKAGE}FullName=${PACKAGEFULLNAME}
+${PACKAGE}MgrPath=${PACKAGEMGRPATH}
+
+ifdef LOG_LOCATION
+ifdef cmt_${PACKAGE}_is_local
+${PACKAGE}OutErr = >>$(LOG_LOCATION)/$(${PACKAGE}FullName)$(LOG_SUFFIX) 2>&1
+else
+ifdef BCAST_GLOBAL
+${PACKAGE}OutErr = >>$(LOG_LOCATION)/$(${PACKAGE}FullName)$(LOG_SUFFIX) 2>&1
+endif
+endif
+endif
+
+ifndef BCAST_ONLY
+${PACKAGE} : ${DEPENDENCIES} $(${PACKAGE}MgrPath)/Makefile
+else
+${PACKAGE} : $(${PACKAGE}MgrPath)/Makefile
+endif
+ifdef cmt_${PACKAGE}_is_local
+	@echo "#--------------------------------------------------------------" \
+	  && echo "# Now trying [$(BCAST_CMD)] in $(${PACKAGE}MgrPath)" \
+	  && echo "#--------------------------------------------------------------"
+ifdef LOG_LOCATION
+	$(silent) touch $(LOG_LOCATION)/$(${PACKAGE}FullName)$(LOG_SUFFIX)
+	@{ echo "#--------------------------------------------------------------" \
+	  && echo "# Now trying [$(BCAST_CMD)] in $(${PACKAGE}MgrPath)" \
+	  && echo "#--------------------------------------------------------------"; } $(${PACKAGE}OutErr)
+endif
+ifdef NO_ALL_GROUPS
+	+$(silent) cd $(${PACKAGE}MgrPath) && $(BCAST_CMD) $(${PACKAGE}OutErr)
+else
+	+$(silent) cd $(${PACKAGE}MgrPath) && \
+	  for group in all $$($(cmtexe) show groups); do \
+	    $(Cmt_actions_handler) \
+	    $(BCAST_CMD) $$group $(${PACKAGE}OutErr); BUILD_RESULT=$$? ; \
+	    $(Package_failure_handler) \
+	  done
+endif
+else
+ifdef BCAST_GLOBAL
+	@echo "#--------------------------------------------------------------" \
+	  && echo "# Now trying [$(BCAST_CMD)] in $(${PACKAGE}MgrPath)" \
+	  && echo "#--------------------------------------------------------------"
+ifdef LOG_LOCATION
+	$(silent) touch $(LOG_LOCATION)/$(${PACKAGE}FullName)$(LOG_SUFFIX)
+	@{ echo "#--------------------------------------------------------------" \
+	  && echo "# Now trying [$(BCAST_CMD)] in $(${PACKAGE}MgrPath)" \
+	  && echo "#--------------------------------------------------------------"; } $(${PACKAGE}OutErr)
+endif
+ifdef NO_ALL_GROUPS
+	+$(silent) cd $(${PACKAGE}MgrPath) && $(BCAST_CMD) $(${PACKAGE}OutErr)
+else
+	+$(silent) cd $(${PACKAGE}MgrPath) && \
+	  for group in all $$($(cmtexe) show groups); do \
+	    $(Cmt_actions_handler) \
+	    $(BCAST_CMD) $$group $(${PACKAGE}OutErr); BUILD_RESULT=$$? ; \
+	    $(Package_failure_handler) \
+	  done
+endif
+else
+	
+endif
+endif
+
+$(${PACKAGE}MgrPath)/Makefile :
+ifdef cmt_${PACKAGE}_is_local
+	$(echo) configuring ${PACKAGE}
+	+$(silent) cd $(${PACKAGE}MgrPath) && $(cmtexe) config
+else
+ifdef BCAST_GLOBAL
+	$(echo) configuring ${PACKAGE}
+	+$(silent) cd $(${PACKAGE}MgrPath) && $(cmtexe) config
+else
+	
+endif
+endif
+
+ifndef BCAST_ONLY
+all : ${PACKAGE}
+clean : ${PACKAGE}clean
+binclean : ${PACKAGE}binclean
+uninstall : ${PACKAGE}uninstall
+endif
+
+${PACKAGE}clean ${PACKAGE}binclean ${PACKAGE}uninstall : $(${PACKAGE}MgrPath)/Makefile
+ifdef cmt_${PACKAGE}_is_local
+	@echo "#--------------------------------------------------------------" \
+	  && echo "# Now trying [$(BCAST_CMD) $(patsubst ${PACKAGE}%,%,$@)] in $(${PACKAGE}MgrPath)" \
+	  && echo "#--------------------------------------------------------------"
+	+$(silent) cd $(${PACKAGE}MgrPath) && $(BCAST_CMD) $(patsubst ${PACKAGE}%,%,$@)
+else
+ifdef BCAST_GLOBAL
+	@echo "#--------------------------------------------------------------" \
+	  && echo "# Now trying [$(BCAST_CMD) $(patsubst ${PACKAGE}%,%,$@)] in $(${PACKAGE}MgrPath)" \
+	  && echo "#--------------------------------------------------------------"
+	+$(silent) cd $(${PACKAGE}MgrPath) && $(BCAST_CMD) $(patsubst ${PACKAGE}%,%,$@)
+else
+	
+endif
+endif
+
+${PACKAGE} ${PACKAGE}clean ${PACKAGE}binclean ${PACKAGE}uninstall : FORCE
Index: CMT/HEAD/mgr/fragments/packages_header
===================================================================
--- CMT/HEAD/mgr/fragments/packages_header	(revision 588)
+++ CMT/HEAD/mgr/fragments/packages_header	(revision 588)
@@ -0,0 +1,60 @@
+#-- start of packages_header ------
+
+include ${CMTROOT}/src/Makefile.core
+
+ifndef BCAST_CMD
+BCAST_CMD = $(cmtexe) make
+endif
+
+ifdef LOG_LOCATION
+LOG_SUFFIX = .log
+endif
+
+ifndef CMTACTIONS
+Cmt_actions_handler = test "$$group" != cmt_actions || continue ;
+else
+Cmt_actions_handler =
+endif
+
+# -- Special macro to change the behavior on a failure of a package
+#    (complementary to the option '-k')
+#  Allowed values for PACKAGE_FAILURE_POLICY:
+#    stop:   do not continue (default)
+#    skip:   if a group fails, continue with the next package
+#    ignore: try all the groups even if one fails before going to the next package
+#            (may result in duplicated errors within a package)
+# Taken from https://svnweb.cern.ch/trac/gaudi/browser/Gaudi/trunk/Makefile.cmt
+Package_failure_handler = test $$BUILD_RESULT -eq 0 || exit $$BUILD_RESULT ;
+ifdef PACKAGE_FAILURE_POLICY
+ifeq ($(PACKAGE_FAILURE_POLICY),stop)
+Package_failure_handler = test $$BUILD_RESULT -eq 0 || exit $$BUILD_RESULT ;
+else
+ifeq ($(PACKAGE_FAILURE_POLICY),skip)
+Package_failure_handler = test $$BUILD_RESULT -eq 0 || break ;
+else
+ifeq ($(PACKAGE_FAILURE_POLICY),ignore)
+Package_failure_handler =
+else
+$(error Unknown PACKAGE_FAILURE_POLICY "$(PACKAGE_FAILURE_POLICY)". Allowed values: "stop" (default), "skip", "ignore")
+endif
+endif
+endif
+endif
+# --
+
+all : ;
+
+ifdef BCAST_ONLY
+all : ${PACKAGE}
+clean : ${PACKAGE}clean
+binclean : ${PACKAGE}binclean
+uninstall : ${PACKAGE}uninstall
+endif
+#--------------------------------------------------------
+
+ifndef PEDANTIC
+.DEFAULT :
+	$(echo) "(uses.make) $@: No rule for such target" >&2
+endif
+
+#-- end of packages_header ------
Index: CMT/HEAD/mgr/fragments/packages_trailer
===================================================================
--- CMT/HEAD/mgr/fragments/packages_trailer	(revision 588)
+++ CMT/HEAD/mgr/fragments/packages_trailer	(revision 588)
@@ -0,0 +1,16 @@
+#-- start of packages_trailer ------
+
+clean uninstall : ;
+
+binclean : FORCE
+ifndef BCAST_ONLY
+ifdef CMTINSTALLAREA
+	$(silent) $(RM) -r $(CMTINSTALLAREA)/$(CMTCONFIG)
+endif
+ifdef LOG_LOCATION
+	$(silent) \find $(LOG_LOCATION) -type f -name '*$(LOG_SUFFIX)' -exec $(RM) '{}' +
+endif
+endif
+
+FORCE :
+#-- end of packages_trailer ------
Index: CMT/HEAD/mgr/fragments/yacc
===================================================================
--- CMT/HEAD/mgr/fragments/yacc	(revision 586)
+++ CMT/HEAD/mgr/fragments/yacc	(revision 588)
@@ -2,4 +2,6 @@
 
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
 
 $(bin)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
Index: CMT/HEAD/mgr/fragments/yacc_library
===================================================================
--- CMT/HEAD/mgr/fragments/yacc_library	(revision 586)
+++ CMT/HEAD/mgr/fragments/yacc_library	(revision 588)
@@ -2,4 +2,6 @@
 
 $(bin)${CONSTITUENT}_dependencies.make : $(${NAME}_${FILESUFFIX}_dependencies)
+
+$(bin)${CONSTITUENT}_dependencies.make : ${FULLNAME}
 
 $(bin)$(binobj)${NAME}${CONSTITUENTSUFFIX}.o : $(${NAME}_${FILESUFFIX}_dependencies)
